## canlock 2b

=== Makefile ===
ANALFLAGS= -pg -W -Wall -pedantic -Wcast-align \
           -Wcast-qual -Wchar-subscripts -Winline \
           -Wmissing-prototypes -Wpointer-arith \
           -Wredundant-decls -Wshadow -Wstrict-prototypes -Wwrite-strings
CFLAGS = -O -Iinclude
LDFLAGS = -L. -lcanlock
LIBOBJS = src/sha1.o src/hmac_sha1.o src/base64.o src/canlock.o
LOCKLIB = libcanlock.a

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

all: sha1test hmactest canlocktest

anal:
	$(MAKE) CFLAGS="$(CFLAGS) $(ANALFLAGS)"

sha1test: t/sha1test.c $(LOCKLIB)
	$(CC) $(CFLAGS) t/$@.c -o $@ $(LDFLAGS)

hmactest: t/hmactest.c $(LOCKLIB)
	$(CC) $(CFLAGS) t/$@.c -o $@ $(LDFLAGS)

canlocktest: t/canlocktest.c $(LOCKLIB)
	$(CC) $(CFLAGS) t/$@.c -o $@ $(LDFLAGS)

src/base64.o: src/base64.c include/base64.h
src/canlock.o: src/canlock.c include/canlock.h
src/hmac_sha1.o: src/hmac_sha1.c include/hmac_sha1.h
src/sha1.o: src/sha1.c include/sha1.h

libs: $(LOCKLIB)
$(LOCKLIB): $(LIBOBJS)
	@echo "Arr, ye be makin' the library matey!"
	ar r $@ $(LIBOBJS)
	ranlib $@
	ln -s include/canlock.h .

clean:
	rm -f src/*.o t/*.o t/*.out *.gmon gmon.*

nuke: clean
	rm -f *.a canlocktest hmactest sha1test *.exe *.h
	
test: all
	@echo "sha1test: "
	@./sha1test > t/sha1test.out
	@diff t/sha1test.shouldbe t/sha1test.out && echo " Pass." || echo " **FAIL**"
	@echo "=-=-=-="
	@echo "hmactest: "
	@./hmactest > t/hmactest.out || echo hmm
	@diff t/hmactest.shouldbe t/hmactest.out && echo " Pass." || echo " **FAIL**"
	@echo "=-=-=-="
	@echo "canlocktest: "
	@./canlocktest > t/canlocktest.out
	@diff t/canlocktest.shouldbe t/canlocktest.out && echo " Pass." || echo " **FAIL**"
	@echo "=-=-=-="

help:
	@echo make options:
	@echo '   anal   compile with lots of warnings enabled.'
	@echo '   libs   build only the library.'
	@echo '   clean  delete stray object files.'
	@echo '   nuke   clean up everything.'

=== debian/changelog ===
canlock (2b-8) unstable; urgency=medium

  * Export hardening flags also for tests, making blhc happy
  * Export _all_ hardening flags
  * Use https for Vcs-Git
  * Declare compliance with Debian Policy 3.9.8
  * Rebuild automatically converts postinst/postrm to trigger for ldconfig

 -- Florian Schlichting <fsfs@debian.org>  Tue, 29 Nov 2016 10:26:43 +0100

canlock (2b-7) unstable; urgency=medium

  * Adopt canlock (closes: #771878)
  * Bump dh compat to level 9
  * Add misc:Depends for libcanlock2-dev to please lintian
  * Add a somewhat useful Homepage field to debian/control
  * Switch to minimal debian/rules
  * Switch to source format 3.0 (quilt), unapply Debian changes to orig tar
    and turn them into quilt patches instead
  * Add install-D.patch: have install create needed directories
  * Convert debian/copyright to copyright-format 1.0
  * Add a symbols control file
  * Drop obsolete libcanlock2-dev.dirs
  * Add hardening.patch to enable use of dpkg-buildflags
  * Declare compliance with Debian Policy 3.9.6
  * Add Vsc-* fields to debian/control

 -- Florian Schlichting <fsfs@debian.org>  Sun, 28 Jun 2015 01:38:11 +0200

canlock (2b-6) unstable; urgency=low

  * Remove bashism in debian/rules (closes: #526455).
    Thanks Michael Bienia.

 -- Laurent Fousse <laurent@komite.net>  Wed, 13 May 2009 22:06:47 +0200

canlock (2b-5) unstable; urgency=low

  * Fix several memleaks (closes: #520444)
    Thanks to Urs Janßen for reporting and providing an initial patch.
  * Update packaging to debhelper compat 7.
  * Update Standard-Version (no change needed).

 -- Laurent Fousse <laurent@komite.net>  Sun, 29 Mar 2009 00:07:35 +0100

canlock (2b-4) unstable; urgency=low

  * Fix insecure buffer usage, could cause stack corruption.
    Thanks Andrey Melnikov for the patch (closes: #355596).
  * Code cleanup: included string.h in sha1.c, no more warning.

 -- Laurent Fousse <laurent@komite.net>  Mon,  6 Mar 2006 23:37:19 +0100

canlock (2b-3) unstable; urgency=low

  * Added missing CFLAGS.

 -- Laurent Fousse <laurent@komite.net>  Fri, 20 Feb 2004 11:34:44 +0100

canlock (2b-2) unstable; urgency=low

  * Failed test target now causes the entire build to fail.
  * No longer need libtool.
  * Fixed buffer size bug in hmac_sha1.c.

 -- Laurent Fousse <laurent@komite.net>  Thu, 19 Feb 2004 12:21:33 +0100

canlock (2b-1) unstable; urgency=low

  * Initial Release (closes: #207389, #204933).

 -- Laurent Fousse <laurent@komite.net>  Thu, 29 Jan 2004 14:12:45 +0000

=== debian/control ===
Source: canlock
Priority: optional
Section: news
Maintainer: Florian Schlichting <fsfs@debian.org>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.8
Homepage: http://albasani.net/wiki/Cancel-Lock
Vcs-Git: https://anonscm.debian.org/git/collab-maint/canlock.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/canlock.git

Package: libcanlock2-dev
Section: libdevel
Architecture: any
Depends: libcanlock2 (= ${binary:Version}), ${misc:Depends}
Description: development files for Usenet cancel lock library
 Cancel locks are used by Usenet article posters to authenticate their
 authorship of an article. It may then by used by servers to prevent
 cancel and supersede abuse. The use of this feature remains the
 newsmaster's decision.
 .
 This library may be used for both the generation and the verification
 of cancel locks. The header file and the static library are included
 in this package.

Package: libcanlock2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for creating and verifying Usenet cancel locks
 Cancel locks are used by Usenet article posters to authenticate their
 authorship of an article. It may then by used by servers to prevent
 cancel and supersede abuse. The use of this feature remains the
 newsmaster's decision.
 .
 This library may be used for both the generation and the verification
 of cancel locks.

## canlock 3.0.1

=== debian/changelog ===
canlock (3.0.1-2) unstable; urgency=medium

  * Let libcanlock-dev conflict with libcanlock2-dev, we ship the same files
  * Upload to unstable

 -- Florian Schlichting <fsfs@debian.org>  Thu, 19 Jul 2018 23:32:09 +0200

canlock (3.0.1-1) experimental; urgency=medium

  * New upstream version 3.0.1
  * Clean up symbols file
  * Move canlock binary into its own package
  * Drop manpage-section.patch, applied upstream
  * Provide libcanlock.h in the old place, we emulate the v2 API
  * Declare compliance with Debian Policy 4.1.5

 -- Florian Schlichting <fsfs@debian.org>  Thu, 19 Jul 2018 08:07:43 +0200

canlock (3.0.0-1) experimental; urgency=medium

  * Move packaging to salsa.d.o
  * Add a watch file for canlock 3.0.0
  * New upstream version 3.0.0
  * Bump dh compat to level 11
  * Rename binary packages for version 3 (soname bump, unversioned -dev,
    updates symbols)
  * Drop obsolete Debian patches for version 2
  * Drop obsolete README.Debian
  * Ship API manpages in dev package
  * Ship canlock binary
  * Update Homepage for version 3
  * Declare compliance with Debian Policy 4.1.3
  * Ship more docs in dev package
  * Update debian/copyright

 -- Florian Schlichting <fsfs@debian.org>  Sat, 10 Mar 2018 18:50:43 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,18 @@
 Priority: optional
 Section: news
 Maintainer: Florian Schlichting <fsfs@debian.org>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.8
-Homepage: http://albasani.net/wiki/Cancel-Lock
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/canlock.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/canlock.git
+Build-Depends: debhelper (>=11)
+Standards-Version: 4.1.5
+Homepage: http://micha.freeshell.org/libcanlock/
+Vcs-Git: https://salsa.debian.org/debian/canlock.git
+Vcs-Browser: https://salsa.debian.org/debian/canlock
 
-Package: libcanlock2-dev
+Package: libcanlock-dev
 Section: libdevel
 Architecture: any
-Depends: libcanlock2 (= ${binary:Version}), ${misc:Depends}
+Depends: libcanlock3 (= ${binary:Version}), ${misc:Depends}
+Conflicts: libcanlock2-dev
+Replaces: libcanlock2-dev
 Description: development files for Usenet cancel lock library
  Cancel locks are used by Usenet article posters to authenticate their
  authorship of an article. It may then by used by servers to prevent
@@ -22,7 +24,7 @@
  of cancel locks. The header file and the static library are included
  in this package.
 
-Package: libcanlock2
+Package: libcanlock3
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -34,3 +36,15 @@
  .
  This library may be used for both the generation and the verification
  of cancel locks.
+
+Package: canlock
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: utility for creating and verifying Usenet cancel locks
+ Cancel locks are used by Usenet article posters to authenticate their
+ authorship of an article. It may then by used by servers to prevent
+ cancel and supersede abuse. The use of this feature remains the
+ newsmaster's decision.
+ .
+ This simple utility wraps the canlock library, and may be used for both
+ the generation and the verification of cancel locks.

=== debian/watch ===
version=3
http://micha.freeshell.org/libcanlock/src/libcanlock-([0-9.]*)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)$

## canlock 3.0.2

=== debian/changelog ===
canlock (3.0.2-2) unstable; urgency=medium

  * Fix a cross-build issue due to the use of AC_RUN_IFELSE (closes: #914375)
  * Add Build-Depends-Package meta-information to the symbols file
  * Specify dh compat level as a dependency, to get rid of d/compat

 -- Florian Schlichting <fsfs@debian.org>  Mon, 03 Dec 2018 23:42:08 +0100

canlock (3.0.2-1) unstable; urgency=medium

  * New upstream version 3.0.2
  * Declare compliance with Debian Policy 4.2.1
  * Switch to secure Homepage and watch URL
  * Explicitly enable legacy (v2) API, we still depend on it in Debian

 -- Florian Schlichting <fsfs@debian.org>  Wed, 12 Sep 2018 21:37:45 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Priority: optional
 Section: news
 Maintainer: Florian Schlichting <fsfs@debian.org>
-Build-Depends: debhelper (>=11)
-Standards-Version: 4.1.5
-Homepage: http://micha.freeshell.org/libcanlock/
+Build-Depends: debhelper-compat (=11)
+Standards-Version: 4.2.1
+Homepage: https://micha.freeshell.org/libcanlock/
 Vcs-Git: https://salsa.debian.org/debian/canlock.git
 Vcs-Browser: https://salsa.debian.org/debian/canlock

## canlock 3.1.0

=== debian/changelog ===
canlock (3.1.0-1) unstable; urgency=medium

  * New upstream version 3.1.0
  * Mark libcanlock3 and -dev packages M-A: same as suggested by the hinter
  * Add upstream metadata file
  * Update copyright years
  * Drop cross3.patch, released upstream
  * Add build-deps on bison and flex for the header parsers
  * Install the canlock header parsers
  * Bump dh compat to level 12
  * Declare compliance with Debian Policy 4.3.0

 -- Florian Schlichting <fsfs@debian.org>  Fri, 15 Feb 2019 00:01:57 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,10 @@
 Priority: optional
 Section: news
 Maintainer: Florian Schlichting <fsfs@debian.org>
-Build-Depends: debhelper-compat (=11)
-Standards-Version: 4.2.1
+Build-Depends: debhelper-compat (=12),
+ bison,
+ flex
+Standards-Version: 4.3.0
 Homepage: https://micha.freeshell.org/libcanlock/
 Vcs-Git: https://salsa.debian.org/debian/canlock.git
 Vcs-Browser: https://salsa.debian.org/debian/canlock
@@ -11,6 +13,7 @@
 Package: libcanlock-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: libcanlock3 (= ${binary:Version}), ${misc:Depends}
 Conflicts: libcanlock2-dev
 Replaces: libcanlock2-dev
@@ -27,6 +30,7 @@
 Package: libcanlock3
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: library for creating and verifying Usenet cancel locks
  Cancel locks are used by Usenet article posters to authenticate their
@@ -40,11 +44,13 @@
 Package: canlock
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: utility for creating and verifying Usenet cancel locks
+Description: utilities for creating and verifying Usenet cancel locks
  Cancel locks are used by Usenet article posters to authenticate their
  authorship of an article. It may then by used by servers to prevent
  cancel and supersede abuse. The use of this feature remains the
  newsmaster's decision.
  .
- This simple utility wraps the canlock library, and may be used for both
- the generation and the verification of cancel locks.
+ This package contains a simple utility wrapping the canlock library,
+ which may be used for both the generation and the verification of
+ cancel locks, along with a message header parser and a header field
+ parser.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-legacy_api

=== debian/watch ===
version=3
https://micha.freeshell.org/libcanlock/src/libcanlock-([0-9.]*)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)$

## canlock 3.2.0

=== debian/changelog ===
canlock (3.2.0-1) unstable; urgency=medium

  * Import new upstream version 3.2.0
  * Update copyright years
  * Ship the pkg-config file
  * Update libcanlock3.symbols: internal symbols are no longer exported
  * Bump dh compat to level 13
  * Declare compliance with Debian Policy 4.5.1
  * Declare that root is not required during build
  * Update d/watch to version 4 (no change required)

 -- Florian Schlichting <fsfs@debian.org>  Thu, 26 Nov 2020 17:25:31 +0800

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-legacy_api --enable-pc-files

## canlock 3.2.1

=== debian/changelog ===
canlock (3.2.1-1) unstable; urgency=medium

  * Import new upstream version 3.2.1

 -- Florian Schlichting <fsfs@debian.org>  Tue, 01 Dec 2020 19:02:40 +0800

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,15 @@
 Priority: optional
 Section: news
 Maintainer: Florian Schlichting <fsfs@debian.org>
-Build-Depends: debhelper-compat (=12),
+Build-Depends: debhelper-compat (=13),
  bison,
- flex
-Standards-Version: 4.3.0
+ flex,
+ pkg-config
+Standards-Version: 4.5.1
 Homepage: https://micha.freeshell.org/libcanlock/
 Vcs-Git: https://salsa.debian.org/debian/canlock.git
 Vcs-Browser: https://salsa.debian.org/debian/canlock
+Rules-Requires-Root: no
 
 Package: libcanlock-dev
 Section: libdevel

## canlock 3.2.2

=== debian/changelog ===
canlock (3.2.2-1) unstable; urgency=medium

  * New upstream version 3.2.2
  * Update copyright years

 -- Florian Schlichting <fsfs@debian.org>  Fri, 29 Jan 2021 09:17:40 +0800

## canlock 3.3.0

=== debian/changelog ===
canlock (3.3.0-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:43:35 +0200

canlock (3.3.0-1) unstable; urgency=medium

  * New upstream version 3.3.0
  * Install hp library
  * Install examples
  * Update symbols
  * Declare compliance with Debian Policy 4.6.0

 -- Florian Schlichting <fsfs@debian.org>  Sat, 08 Jan 2022 18:37:27 +0800

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: canlock
 Priority: optional
 Section: news
-Maintainer: Florian Schlichting <fsfs@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Florian Schlichting <fsfs@debian.org>
 Build-Depends: debhelper-compat (=13),
  bison,
  flex,
  pkg-config
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://micha.freeshell.org/libcanlock/
 Vcs-Git: https://salsa.debian.org/debian/canlock.git
 Vcs-Browser: https://salsa.debian.org/debian/canlock

## canlock 3.3.1

=== debian/changelog ===
canlock (3.3.1-1) unstable; urgency=medium

  * New upstream version 3.3.1
  * Update d/copyright: update license name, bump years
  * Build-Depend on pkgconf instead of obsolete pkg-config
  * Clean files only cleaned by "make maintainer-clean" (closes: 1044006)
  * Declare compliance with Debian Policy 4.7.2

 -- Florian Schlichting <fsfs@debian.org>  Mon, 17 Mar 2025 22:44:47 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: canlock
 Priority: optional
 Section: news
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Florian Schlichting <fsfs@debian.org>
+Maintainer: Florian Schlichting <fsfs@debian.org>
 Build-Depends: debhelper-compat (=13),
  bison,
  flex,
- pkg-config
-Standards-Version: 4.6.0
+ pkgconf
+Standards-Version: 4.7.2
 Homepage: https://micha.freeshell.org/libcanlock/
 Vcs-Git: https://salsa.debian.org/debian/canlock.git
 Vcs-Browser: https://salsa.debian.org/debian/canlock

=== debian/rules ===
--- 
+++ 
@@ -7,3 +7,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- --enable-legacy_api --enable-pc-files
+
+override_dh_auto_clean:
+	-make maintainer-clean
+	dh_auto_clean

=== debian/watch ===
version=4
https://micha.freeshell.org/libcanlock/src/libcanlock-([0-9.]*)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)$
